<!-- table -->
<app-table
  (pagingChange)="emitPagingChange($event)"
  (sortChange)="emitSortsChange()"
  [columns]="columns"
  [loading]="loading"
  [page]="page"
  [rows]="data"
  [size]="size"
  [loadLabel]="loadMoreLable"
  [total]="total"
>
  <!-- name column -->
  <ng-template appTableBodyCell columnProperty="name" let-space="row" let-name="value">
    <!-- link -->
    <app-tooltip position="top">
      <a (click)="openSpaceInfo(space)" class="app-link name">
        {{ name }}
      </a>
      <b tooltip>
        {{ name }}
      </b>
    </app-tooltip>
  </ng-template>

  <!-- associated devices -->
  <ng-template appTableBodyCell columnProperty="associatedDevices" let-space="row" let-associatedDevices="value">
    <!-- associations -->
    <app-associations
      (addClick)="openAddAssociation(space, associatedDevices, 'device')"
      [associations]="associatedDevices"
      [readOnly]="readOnly$ | async"
      type="device"
    ></app-associations>
  </ng-template>

  <!-- associated keyholders -->
  <ng-template appTableBodyCell columnProperty="associatedKeyholders" let-space="row" let-associatedKeyholders="value">
    <!-- associations -->
    <app-associations
      (addClick)="openAddAssociation(space, associatedKeyholders, 'keyholder')"
      [associations]="associatedKeyholders"
      [readOnly]="readOnly$ | async"
      type="keyholder"
    ></app-associations>
  </ng-template>

  <!-- state column -->
  <ng-template appTableBodyCell columnProperty="state" let-space="row">
    <span class="column-label dh ms">STATE</span>
    <!-- state label -->
    <app-state-label [state]="space.state" [status]="space.status" type="space"></app-state-label>
  </ng-template>

  <!-- last access -->
  <ng-template appTableBodyCell columnProperty="lastAccess" let-space="row">
    <span class="column-label dh ms">last accessed</span>
    <!-- user info -->
    <app-user-info *ngIf="space.lastAccess" [user]="space.lastAccess.keyholder" type="custom">
      <!-- custom content -->
      <a
        (click)="openAccessHistory(space)"
        *ngIf="accessHistoryReadPermission$ | async"
        class="app-link view-more"
        custom
      >
        VIEW MORE
      </a>
    </app-user-info>
  </ng-template>

  <!-- map -->
  <ng-template appTableBodyCell columnProperty="map" let-space="row">
    <div class="app-map">
      <!-- tooltip -->
      <app-tooltip class="ds mh" *ngIf="space.lastAccess && space.lastAccess.map" position="top">
        <!-- map icon -->
        <app-icon-map></app-icon-map>
        <b tooltip>
          View Map
        </b>
      </app-tooltip>

      <!-- more options -->
      <app-more-options #more *ngIf="editPermission$ | async">
        <!-- edit -->
        <button (click)="openSpaceEdit(space); more.close()" appIconButton>
          <!-- pencil -->
          <app-icon-pencil></app-icon-pencil>
          Edit
        </button>

        <!-- delete -->
        <button (click)="openDeleteConfirmModal(space); more.close()" appIconButton>
          <!-- delete -->
          <app-icon-delete></app-icon-delete>
          Delete
        </button>
      </app-more-options>
    </div>
  </ng-template>
</app-table>

<!-- add associations modal -->
<app-side-modal-add-association
  (applied)="onAssociationApplied($event)"
  (closeClick)="closeAddAssociation()"
  *ngIf="addAssociationVisible"
  [associations]="associations"
  [space]="selectedSpace"
  [type]="associationType"
></app-side-modal-add-association>

<!-- space info -->
<app-side-modal-space-info
  (updated)="onInfoUpdated()"
  (closeClick)="closeSpaceInfo()"
  *ngIf="spaceInfoVisible"
  [space]="selectedSpace"
></app-side-modal-space-info>

<!-- access history -->
<app-side-modal-access-history
  (closeClick)="closeAccessHistory()"
  *ngIf="accessHistoryVisible"
  [space]="selectedSpace"
  type="space"
></app-side-modal-access-history>

<!-- delete confirm -->
<app-delete-modal
  (closeClick)="closeDeleteConfirmModal()"
  (confirmClick)="deleteSpace()"
  *ngIf="deleteModalVisible"
  [loading]="deleteLoading"
>
  Are you sure want to delete Space {{ selectedSpace.id }} ?
</app-delete-modal>
